LightWayTxtParser Class Reference documentation

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
LightWayTxtParser Class Reference

the main class to read a LightWay Text file More...

`#include <LightWayTxtParser.hxx>`

Inheritance diagram for LightWayTxtParser:

## Public Member Functions
| LightWayTxtParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~LightWayTxtParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGTextInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWTextParser
virtual | ~MWAWTextParser ()
| destructor More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | init ()
| inits all internal variables More...
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document More...
MWAWVec2f | getPageLeftTop () const
| returns the page left top point ( in inches) More...
bool | getColumnInfo (int &numCols, int &colSep) const
| returns the number of column and the column separator (in point) More...
void | newPage (int number)
| adds a new page More...
bool | textInDataFork () const
| returns true if the main text is in data fork More...
void | sendGraphic (int graphId)
| ask the graph parser to send a graph More...
bool | sendHeaderFooter (bool header)
| try to send the header/footer More...
bool | createZones ()
| finds the different objects zones More...
bool | readPrintInfo (MWAWEntry const &entry)
| read a PrintInfo block More...
bool | readDocInfo (MWAWEntry const &entry)
| read a DocInfo block More...
bool | readDocument (MWAWEntry const &entry)
| read a Document, Header/Footer block (1000) More...
bool | readLWSR2 (MWAWEntry const &entry)
| read a LWSR block (1002) More...
bool | readMPSR5 (MWAWEntry const &entry)
| read a MPSR block (1005) More...
bool | readTOCPage (MWAWEntry const &entry)
| read a TOC page block More...
bool | readTOC (MWAWEntry const &entry)
| read a TOC data block More...
MWAWInputStreamPtr | rsrcInput ()
| return the input input More...
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc More...
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWTextParser (MWAWParserStatePtr state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes
shared_ptr< LightWayTxtParserInternal::State > | m_state
| the state More...
bool | m_pageSpanSet
| a flag to know if page span has been set More...
shared_ptr< LightWayTxtGraph > | m_graphParser
| the graph parser More...
shared_ptr< LightWayTxtText > | m_textParser
| the text parser More...

## Friends
class | LightWayTxtParserInternal::SubDocument
class | LightWayTxtGraph
class | LightWayTxtText

## Detailed Description

the main class to read a LightWay Text file

## Constructor & Destructor Documentation

LightWayTxtParser::LightWayTxtParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

LightWayTxtParser::~LightWayTxtParser | ( |  | ) |
| virtual

destructor

## Member Function Documentation

bool LightWayTxtParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

void LightWayTxtParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

bool LightWayTxtParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

bool LightWayTxtParser::getColumnInfo | ( | int & | numCols,
|  | int & | colSep
| ) |  | const
| protected

returns the number of column and the column separator (in point)

Referenced by LightWayTxtText::sendMainText().

MWAWVec2f LightWayTxtParser::getPageLeftTop | ( |  | ) | const
| protected

returns the page left top point ( in inches)

void LightWayTxtParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by LightWayTxtParser().

void LightWayTxtParser::newPage | ( | int | number | ) |
| protected

adds a new page

void LightWayTxtParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| virtual

virtual function used to parse the input

Implements MWAWTextParser.

bool LightWayTxtParser::readDocInfo | ( | MWAWEntry const & | entry | ) |
| protected

read a DocInfo block

Referenced by createZones().

bool LightWayTxtParser::readDocument | ( | MWAWEntry const & | entry | ) |
| protected

read a Document, Header/Footer block (1000)

Referenced by createZones().

bool LightWayTxtParser::readLWSR2 | ( | MWAWEntry const & | entry | ) |
| protected

read a LWSR block (1002)

Referenced by createZones().

bool LightWayTxtParser::readMPSR5 | ( | MWAWEntry const & | entry | ) |
| protected

read a MPSR block (1005)

Referenced by createZones().

bool LightWayTxtParser::readPrintInfo | ( | MWAWEntry const & | entry | ) |
| protected

read a PrintInfo block

Referenced by createZones().

bool LightWayTxtParser::readTOC | ( | MWAWEntry const & | entry | ) |
| protected

read a TOC data block

Referenced by createZones().

bool LightWayTxtParser::readTOCPage | ( | MWAWEntry const & | entry | ) |
| protected

read a TOC page block

Referenced by createZones().

libmwaw::DebugFile & LightWayTxtParser::rsrcAscii | ( |  | ) |
| protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by readDocInfo(), readDocument(), LightWayTxtText::readDocumentHF(), LightWayTxtText::readFont2(), LightWayTxtText::readFonts(), readLWSR2(), readMPSR5(), readPrintInfo(), LightWayTxtText::readRuby(), LightWayTxtText::readRulers(), LightWayTxtText::readStyleU(), readTOC(), readTOCPage(), LightWayTxtText::readUnknownStyle(), LightWayTxtGraph::sendJPEG(), and LightWayTxtText::sendMainText().

MWAWInputStreamPtr LightWayTxtParser::rsrcInput | ( |  | ) |
| protected

return the input input

Referenced by readDocInfo(), readDocument(), LightWayTxtText::readDocumentHF(), LightWayTxtText::readFont2(), LightWayTxtText::readFonts(), readLWSR2(), readMPSR5(), readPrintInfo(), LightWayTxtText::readRuby(), LightWayTxtText::readRulers(), LightWayTxtText::readStyleU(), readTOC(), readTOCPage(), LightWayTxtText::readUnknownStyle(), sendGraphic(), sendHeaderFooter(), LightWayTxtText::sendHeaderFooter(), LightWayTxtGraph::sendJPEG(), and LightWayTxtText::sendMainText().

void LightWayTxtParser::sendGraphic | ( | int | graphId | ) |
| protected

ask the graph parser to send a graph

Referenced by LightWayTxtText::sendMainText().

bool LightWayTxtParser::sendHeaderFooter | ( | bool | header | ) |
| protected

try to send the header/footer

Referenced by LightWayTxtParserInternal::SubDocument::parse().

bool LightWayTxtParser::textInDataFork | ( |  | ) | const
| protected

returns true if the main text is in data fork

Referenced by LightWayTxtText::sendMainText().

## Friends And Related Function Documentation

friend class LightWayTxtGraph
| friend

Referenced by init().

friend class LightWayTxtParserInternal::SubDocument
| friend

friend class LightWayTxtText
| friend

Referenced by init().

## Member Data Documentation

shared_ptr<LightWayTxtGraph> LightWayTxtParser::m_graphParser
| protected

the graph parser

Referenced by createDocument(), createZones(), init(), parse(), and sendGraphic().

bool LightWayTxtParser::m_pageSpanSet
| protected

a flag to know if page span has been set

Referenced by readDocument(), and readPrintInfo().

shared_ptr<LightWayTxtParserInternal::State> LightWayTxtParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), getColumnInfo(), getPageLeftTop(), init(), newPage(), readDocument(), and textInDataFork().

shared_ptr<LightWayTxtText> LightWayTxtParser::m_textParser
| protected

the text parser

Referenced by createDocument(), createZones(), init(), parse(), readDocument(), and sendHeaderFooter().

The documentation for this class was generated from the following files:

- LightWayTxtParser.hxx
- LightWayTxtParser.cxx